//                        in the name of ogd
#ifndef GLCD_TFUNCTIONS_H
#define GLCD_TFUNCTIONS_H

#include <avr/io.h>
#include <avr/pgmspace.h>
#include "Font_8x16.h"
#include "Glcd_GFunctions.h"
#include "Glcd_TFunctions.h"

unsigned char x_text=0,y_text=0;

void lcd_gotoxy(unsigned char x,unsigned char y)
    {
    if(x>40 || y>15) 
        {
        y+=x/40;
        x%=40;
        }
    x_text=x;
    y_text=y;
    }

void lcd_putchar(char character,int forground_color,char background_color_activation,int background_color)
    {  
	uint16_t TMP_character=((uint16_t)character-0x20)*16;
    int temporary_color;
    unsigned char width_counter,length_counter;
    char character_segment_data;
    for(length_counter=0;length_counter<16;length_counter++)
        {
        character_segment_data=pgm_read_byte(&font8x16[TMP_character+length_counter]);
        for(width_counter=0;width_counter<8;width_counter++)
            {
            if(character_segment_data&(0b10000000>>width_counter)) 
              lcd_write_pixel(((int)x_text*8)+width_counter,((int)y_text*16)+length_counter,forground_color);
            else 
              {
              if(background_color_activation)
                {
                temporary_color=lcd_read_rdr();
                temporary_color=lcd_read_rdr();
                lcd_write_wdr(temporary_color);
                } 
              else
                lcd_write_pixel(((int)x_text*8)+width_counter,((int)y_text*16)+length_counter,background_color);
              }            
            }
        }
    
    if(++x_text>40)
        {            
        x_text=0;
        if(++y_text>15) y_text=0;
        }
    }  
    
    

#endif	/*GLCD_TFUNCTIONS_H*/
